1 Star 0 Fork 6

xianwj/dsms-storage

forked from anolis/dsms-storage 
加入 Gitee
与超过 1200万 开发者一起发现、参与优秀开源项目,私有仓库也完全免费 :)
免费加入
克隆/下载
make-dist 6.35 KB
一键复制 编辑 原始数据 按行查看 历史
吴秀巧 提交于 2022-12-21 19:29 . Add storage code
#!/bin/bash -e
SCRIPTNAME="$(basename "${0}")"
BASEDIR="$(readlink -f "$(dirname "${0}")")"
if [ ! -d .git ]; then
echo "$SCRIPTNAME: Full path to the script: $BASEDIR/$SCRIPTNAME"
echo "$SCRIPTNAME: No .git present. Run this from the base dir of the git checkout."
exit 1
fi
# Running the script from a directory containing a colon anywhere in the path
# will expose us to the dreaded "[BUG] npm run [command] failed if the directory
# path contains colon" bug https://github.com/npm/cli/issues/633
# (see https://tracker.ceph.com/issues/39556 for details)
if [[ "$BASEDIR" == *:* ]] ; then
echo "$SCRIPTNAME: Full path to the script: $BASEDIR/$SCRIPTNAME"
echo "$SCRIPTNAME: The path to the script contains a colon. Their presence has been known to break the script."
exit 1
fi
version=$1
[ -z "$version" ] && version=$(git describe --long --match 'v*' | sed 's/^v//')
if expr index $version '-' > /dev/null; then
rpm_version=$(echo $version | cut -d - -f 1-1)
rpm_release=$(echo $version | cut -d - -f 2- | sed 's/-/./')
else
rpm_version=$version
rpm_release=0
fi
outfile="ceph-$version"
echo "version $version"
# update submodules
echo "updating submodules..."
force=$(if git submodule usage 2>&1 | grep --quiet 'update.*--force'; then echo --force ; fi)
if ! git submodule sync || ! git submodule update $force --init --recursive; then
echo "Error: could not initialize submodule projects"
echo " Network connectivity might be required."
exit 1
fi
download_boost() {
boost_version=$1
shift
boost_sha256=$1
shift
boost_version_underscore=$(echo $boost_version | sed 's/\./_/g')
boost_fname=boost_${boost_version_underscore}.tar.bz2
set +e
while true; do
url_base=$1
shift
if [ -z $url_base ]; then
echo "Error: failed to download boost."
exit
fi
url=$url_base/$boost_fname
wget -c --no-verbose -O $boost_fname $url
if [ $? != 0 -o ! -e $boost_fname ]; then
echo "Download of $url failed"
elif [ $(sha256sum $boost_fname | awk '{print $1}') != $boost_sha256 ]; then
echo "Error: failed to download boost: SHA256 mismatch."
else
break
fi
done
set -e
tar xjf $boost_fname -C src \
--exclude="$boost_version_underscore/libs/*/doc" \
--exclude="$boost_version_underscore/libs/*/example" \
--exclude="$boost_version_underscore/libs/*/examples" \
--exclude="$boost_version_underscore/libs/*/meta" \
--exclude="$boost_version_underscore/libs/*/test" \
--exclude="$boost_version_underscore/tools/boostbook" \
--exclude="$boost_version_underscore/tools/quickbook" \
--exclude="$boost_version_underscore/tools/auto_index" \
--exclude='doc' --exclude='more' --exclude='status'
mv src/boost_${boost_version_underscore} src/boost
tar cf ${outfile}.boost.tar ${outfile}/src/boost
rm -rf src/boost
}
build_dashboard_frontend() {
CURR_DIR=`pwd`
TEMP_DIR=`mktemp -d`
$CURR_DIR/src/tools/setup-virtualenv.sh $TEMP_DIR
$TEMP_DIR/bin/pip install nodeenv
$TEMP_DIR/bin/nodeenv --verbose -p --node=10.18.1
cd src/pybind/mgr/dashboard/frontend
DEFAULT_LANG=`jq -r .config.locale package.json`
if [ -z "$DASHBOARD_FRONTEND_LANGS" ]; then
BUILD_TARGET=":${DEFAULT_LANG}"
else
if [ "$DASHBOARD_FRONTEND_LANGS" == "ALL" ]; then
BUILD_TARGET=":*"
else
DASHBOARD_FRONTEND_LANGS_LIST=`echo "$DASHBOARD_FRONTEND_LANGS" | sed 's/ /,/g'`
if [[ $DASHBOARD_FRONTEND_LANGS_LIST != *"${DEFAULT_LANG}"* ]]; then
# default language must be always built
DASHBOARD_FRONTEND_LANGS_LIST="${DASHBOARD_FRONTEND_LANGS},${DEFAULT_LANG}"
fi
BUILD_TARGET=":{${DASHBOARD_FRONTEND_LANGS_LIST}}"
fi
fi
# number of frontend languages to build in parallel - default to 1 to work
# around https://tracker.ceph.com/issues/43152
[ -z "$MAX_DASHBOARD_PARALLEL_BUILDS" ] && MAX_DASHBOARD_PARALLEL_BUILDS=1
. $TEMP_DIR/bin/activate
NG_CLI_ANALYTICS="false" timeout 1h npm ci
echo "Building ceph-dashboard frontend with build${BUILD_TARGET} script";
# we need to use "-- --" because so that "--prod" survives accross all
# scripts redirections inside package.json
npx npm-run-all --print-label --parallel --max-parallel $MAX_DASHBOARD_PARALLEL_BUILDS "build${BUILD_TARGET} -- -- --prod"
deactivate
cd $CURR_DIR
rm -rf $TEMP_DIR
tar cf dashboard_frontend.tar $outfile/src/pybind/mgr/dashboard/frontend/dist
}
generate_rook_ceph_client() {
$outfile/src/pybind/mgr/rook/generate_rook_ceph_client.sh
tar cf rook_ceph_client.tar $outfile/src/pybind/mgr/rook/rook_client/*.py
}
# clean out old cruft...
echo "cleanup..."
rm -f $outfile*
# build new tarball
echo "building tarball..."
bin/git-archive-all.sh --prefix ceph-$version/ \
--verbose \
--ignore corpus \
$outfile.tar
# populate files with version strings
echo "including src/.git_version, ceph.spec"
(git rev-parse HEAD ; echo $version) 2> /dev/null > src/.git_version
for spec in ceph.spec.in alpine/APKBUILD.in; do
cat $spec |
sed "s/@PROJECT_VERSION@/$rpm_version/g" |
sed "s/@RPM_RELEASE@/$rpm_release/g" |
sed "s/@TARBALL_BASENAME@/ceph-$version/g" > `echo $spec | sed 's/.in$//'`
done
ln -s . $outfile
tar cvf $outfile.version.tar $outfile/src/.git_version $outfile/ceph.spec $outfile/alpine/APKBUILD
# NOTE: If you change this version number make sure the package is available
# at the three URLs referenced below (may involve uploading to download.ceph.com)
boost_version=1.72.0
download_boost $boost_version 59c9b274bc451cf91a9ba1dd2c7fdcaf5d60b1b3aa83f2c9fa143417cc660722 \
https://boostorg.jfrog.io/artifactory/main/release/$boost_version/source \
https://downloads.sourceforge.net/project/boost/boost/$boost_version \
https://download.ceph.com/qa
build_dashboard_frontend
generate_rook_ceph_client
tar --concatenate -f $outfile.all.tar $outfile.version.tar
tar --concatenate -f $outfile.all.tar $outfile.boost.tar
tar --concatenate -f $outfile.all.tar $outfile.tar
tar --concatenate -f $outfile.all.tar dashboard_frontend.tar
tar --concatenate -f $outfile.all.tar rook_ceph_client.tar
mv $outfile.all.tar $outfile.tar
rm $outfile
rm -f $outfile.version.tar
rm -f $outfile.boost.tar
echo "compressing..."
bzip2 -9 $outfile.tar
echo "done."
马建仓 AI 助手
尝试更多
代码解读
代码找茬
代码优化
1
https://gitee.com/wjxian_1/dsms-storage.git
git@gitee.com:wjxian_1/dsms-storage.git
wjxian_1
dsms-storage
dsms-storage
master

搜索帮助